<html>
<head>
<title>RManNotes: Regular Patterns: Texture Coordinates</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="reg_patterns.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="mod.html">previous</a>
|
<a href="shapes.html">next</a>
|
<a href="index.html">regular patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1><a name="top">Transforming Tiles</a></h1>

<p>
When it is necessary to create patterns at angles, particular scales, 
or positions, it is usually easier to transform the texture coordinates 
rather than the pattern itself. Texture coordinate transformations are
easy, while generating patterns is usually more difficult.
</p>

<p>
Transforming texture coordinates has an "inverse" 
effect on the appearance of the pattern. For example, if you 
scale the texture coordinates by a factor of 2, the frequency of
the pattern will double and the pattern will appear twice as small. 
Likewise, positive translations will move the pattern up and to the 
left (the opposite direction) and positive clockwise 
rotations will rotate the pattern counter-clockwise.
</p>

<h2><a name="rotate2d">Rotating Tiles</a></h2>

<table border=3 cellpadding=5 width=100%>
<tr><td>
<p align=right><small>RManNotes function</small></p>
<p>
<b>rotate2d(float x, y, angle, ox, oy, rx, ry)</b>
</p>
<p>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<i>Rotates a 2D point (<code>x</code>, <code>y</code>) clockwise
by a specified <code>angle</code> (in radians) about an origin
(<code>ox</code>, <code>oy</code>) and stores the 
resulting point in (<code>rx</code>, <code>ry</code>). 
</i></p>
<p align=center>
<img src="rotate2d.gif">
</p>
</table>

<p>
An RManNotes function called <b><i>rotate2d</i></b> makes it easy to
rotate 2D texture coordinates. Remember that this is a clockwise
rotation, therefore when applied to texture coordinates, the pattern will be
rotated <i>counter clockwise</i>.
</p>

<p>
To rotate the <a href="mod.html#cross">cross shader</a>, we replace
the lines
</p>

<p>
<pre>
  ss = repeat(s, freq);
  tt = repeat(t, freq);
</pre>
</p>

<p>
with
</p>
<pre>
  rotate2d(s, t, radians(45), 0.5, 0.5, ss, tt);
  ss = repeat(ss, freq);
  tt = repeat(tt, freq);
</pre>
<p>
to get
</p>

<p align=center>
<img src="rotcross.gif"><br>
<a href="rotcross.sl">rotcross.sl</a>
</p>

<h2><a name="shift">Shifting Rows or Columns of Tiles</a></h2>

Alternating rows (or columns) of tiles can be staggered by 
<ol>
<li>using <a href="mod.html#sstt"><code>repeat</code></a>, 
<a href="mod.html#which"><code>whichtile</code></a>, 
and <a href="mod.html#which"><code>odd</code></a> and/or 
<a href="mod.html#which"><code>even</code></a>
to determine if the current tile is in an odd or even row; and then 
<li>shifting or not shifting texture or coordinates appropriately.
</ol>
<p>

<p>
For example, to shift even rows of a pattern by a 1/2 tile, you 
would add 0.5 to <code>ss</code> after it has been repeated. You still
need to remember to mod <code>ss</code> with 1 so that 
it stays in the range 0 to 1.
<pre>
  row = whichtile(t, freq);
  if (even(row))
    ss = mod(ss + 0.5, 1);
</pre>
</p>

<p align=center>
<img src="shiftedblocks.gif"><br>
<a href="shiftedblocks.sl">shiftedblocks.sl</a>
</p>

<p>
<i>Note: shiftedblocks.sl uses a function called
<a href="shapes.html#bool">intersection</a> which is described in the 
section on generating simple <a href="shapes.html">shapes</a>.</i>
</p>

<h2><a name="topolar2d">Polar Coordinates</a></h2>

<p>
Polar coordinates are useful for generating radially shaped patterns (flowers, stars, etc.). The convenience function <b><i>topolar2d</i></b>
converts a 2-D point in Cartesian coordinates to polar coordinates.
</p>

<table border=3 cellpadding=5 width=100%>
<tr><td>
<p align=right><small>RManNotes function</small></p>
<p>
<b>topolar2d(float x, y, r, theta)</b>
</p>
<p>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<i>Transforms a 2-D point (<code>x,y</code>) in Cartesian coordinates
to polar coordinates expressed in terms of <code>r</code> 
(distance from the origin) and <code>theta</code> 
(the angle expressed in radians). <code>theta</code> will be in 
the range [-PI, PI].
<i></p>
</table>

<p><img src="black_line.gif"></p>
<p>
<a href="mod.html">previous</a>
|
<a href="shapes.html">next</a>
|
<a href="index.html">regular patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 3/29/96</i></small></p>

</body>
</html>
